-----------------------------------------------------
-- lua 파일이 여러개인 경우
-- 애드온명, 애드온내공유테이블이 ...으로 전달됨
-----------------------------------------------------
local addonName, L = ...;

local LJDCastingBarFrame = CreateFrame("FRAME");
LJDCastingBarFrame:SetScript('OnEvent', function(self, event, ...)
    return self:Events(event, ...);
end)


LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_SENT");

LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START");
LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE");
LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_DELAYED");
LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_START");

LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED");
LJDCastingBarFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");

--LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP");
--LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_INTERRUPTIBLE");
--LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_NOT_INTERRUPTIBLE");
--LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_STOP");
--LJDCastingBarFrame:RegisterEvent("UNIT_SPELLCAST_FAILED");

LJDCastingBarFrame:RegisterEvent("UPDATE_MOUSEOVER_UNIT");
LJDCastingBarFrame:RegisterEvent("PLAYER_TARGET_CHANGED");
LJDCastingBarFrame:RegisterEvent("PLAYER_ENTERING_WORLD");

function LJDCastingBarFrame:Events(...)
    local ll = {...};
    local event = ll[1];
    --DebugPrint(event);
    --DebugPrint(self);
    --DebugPrintTable(self);
    
    if( event == "PLAYER_ENTERING_WORLD" ) then
        self:PLAYER_ENTERING_WORLD();
    elseif( event == "PLAYER_TARGET_CHANGED" ) then
        self:PLAYER_TARGET_CHANGED(unpack(ll));
    elseif( event == "UPDATE_MOUSEOVER_UNIT" ) then
        self:UPDATE_MOUSEOVER_CHANGED(unpack(ll));
    elseif( event == "UNIT_SPELLCAST_INTERRUPTED" or event == "COMBAT_LOG_EVENT_UNFILTERED" ) then
        self:LJDShowInterrupter(unpack(ll));
    else
        local unitId = ll[2];
        local startSpellId = ll[4];

        LJDShowCastingBar(unitId, startSpellId);
        LJDShowCastingSpellToolip(unitId, startSpellId);
    end
end

function LJDCastingBarFrame:PLAYER_ENTERING_WORLD()

    -- 캐스트바 프레임 생성(target 전용)
    local castBar = _G["LJDCastingBar"];
    if( not castBar ) then

        castBar = CreateFrame("Frame", "LJDCastingBar", UIParent, BackdropTemplateMixin and "BackdropTemplate");
        castBar:SetBackdrop({edgeFile='interface/buttons/white8x8', edgeSize=2});
        castBar:SetBackdropBorderColor(0,0,0,0.4)
        
        castBar:SetPoint("TOP", UIParent, "TOP", 0, -50);
        
        castBar:SetMovable(true);
        castBar:EnableMouse(true);
        castBar:RegisterForDrag("LeftButton");
        castBar:SetScript("OnDragStart", castBar.StartMoving);
        castBar:SetScript("OnDragStop", castBar.StopMovingOrSizing);
        castBar:SetSize(800,32);

        castBar.progressBar = CreateFrame("StatusBar", "LJDCastingBarProgressBar", castBar, "CastingBarFrameTemplate");
        castBar:SetFrameStrata("LOW");   -- 가방뒤로 보낼려고
        castBar:SetFrameLevel(101);      -- 퀘스트 위에 보일려고
        --castBar.progressBar:SetScript("OnShow", function(self) self:GetParent():Show(); end);
        castBar.progressBar:SetScript("OnHide", function(self) self:GetParent():Hide(); end);
        --castBar.progressBar:SetAllPoints();
        castBar.progressBar:SetPoint("TOPLEFT", castBar ,"TOPLEFT", 2, -2);
        castBar.progressBar:SetPoint("BOTTOMRIGHT", castBar ,"BOTTOMRIGHT", -2, 2);

        --castBar.progressBar.Border:SetSize(254,64);
        --castBar.progressBar.BorderShield:SetSize(254,64);
        
        castBar.progressBar.Text:ClearAllPoints();
        castBar.progressBar.Text:SetAllPoints();
        castBar.progressBar.Text:SetPoint("CENTER", 0, 0);
        castBar.progressBar.Text:SetFont(STANDARD_TEXT_FONT, 16, "OUTLINE");
        --castBar.progressBar.Text:SetTextHeight(20);
        --castBar.progressBar.Text:SetSize(185,16);

        -- 캐스트중인 대상표현
        castBar.progressBar.TargetText = castBar.progressBar:CreateFontString(nil, "OVERLAY");
        castBar.progressBar.TargetText:SetPoint("LEFT", 20, 0);
        castBar.progressBar.TargetText:SetPoint("RIGHT", -20, 0);
        castBar.progressBar.TargetText:SetFont([[Fonts\2002.TTF]], 16, "OUTLINE");
        castBar.progressBar.TargetText:SetJustifyH("LEFT");
        castBar.progressBar.TargetText:SetText("캐스트대상"); -- 테스트용

        -- 차단자 표현
        castBar.progressBar.InterrupterText = castBar.progressBar:CreateFontString(nil, "OVERLAY");
        castBar.progressBar.InterrupterText:SetPoint("LEFT", 20, 0);
        castBar.progressBar.InterrupterText:SetPoint("RIGHT", -20, 0);
        castBar.progressBar.InterrupterText:SetFont([[Fonts\2002.TTF]], 16, "OUTLINE");
        castBar.progressBar.InterrupterText:SetJustifyH("RIGHT");
        castBar.progressBar.InterrupterText:SetText("차단자"); -- 테스트용

        castBar.progressBar.Icon:SetSize(32,32);
        
        castBar.progressBar.Spark:SetSize(32,32);
        castBar.progressBar.Flash:ClearAllPoints();
        --castBar.progressBar.Flash:SetAllPoints();
        castBar.progressBar.Flash:SetPoint("CENTER", 0, 0);
        castBar.progressBar.Flash:SetSize(1000,64);
        castBar.progressBar.Border:Hide();

        CastingBarFrame_OnLoad(castBar.progressBar, nil, true, false);
        
        -- hooksecurefunc("CastingBarFrame_OnUpdate" 으로 처리함
        --castBar.progressBar:HookScript("OnUpdate", LJDShowCastingBar_OnUpdate );
        
        castBar:Hide();
    end

    -- 캐스트바 프레임 생성(MouseOver 전용툴팁)
    local castBarMO = _G["LJDCastingBarMO"];
    if( not castBarMO ) then

        castBarMO = CreateFrame("Frame", "LJDCastingBarMO", UIParent, BackdropTemplateMixin and "BackdropTemplate");
        castBarMO:SetBackdrop({edgeFile='interface/buttons/white8x8', edgeSize=2});
        castBarMO:SetBackdropBorderColor(0,0,0,0.4)
        
        castBarMO:SetPoint("TOP", UIParent, "TOP", 0, -50);
        
        castBarMO:SetMovable(true);
        castBarMO:EnableMouse(true);
        castBarMO:RegisterForDrag("LeftButton");
        castBarMO:SetScript("OnDragStart", castBarMO.StartMoving);
        castBarMO:SetScript("OnDragStop", castBarMO.StopMovingOrSizing);
        castBarMO:SetSize(800,32);

        castBarMO.progressBar = CreateFrame("StatusBar", "LJDCastingBarMOProgressBar", castBarMO, "CastingBarFrameTemplate");
        castBarMO:SetFrameStrata("LOW");   -- 가방뒤로 보낼려고
        castBarMO:SetFrameLevel(101);      -- 퀘스트 위에 보일려고
        --castBarMO.progressBar:SetScript("OnShow", function(self) self:GetParent():Show(); end);
        castBarMO.progressBar:SetScript("OnHide", function(self) self:GetParent():Hide(); end);
        --castBarMO.progressBar:SetAllPoints();
        castBarMO.progressBar:SetPoint("TOPLEFT", castBarMO ,"TOPLEFT", 2, -2);
        castBarMO.progressBar:SetPoint("BOTTOMRIGHT", castBarMO ,"BOTTOMRIGHT", -2, 2);

        --castBarMO.progressBar.Border:SetSize(254,64);
        --castBarMO.progressBar.BorderShield:SetSize(254,64);
        
        castBarMO.progressBar.Text:ClearAllPoints();
        castBarMO.progressBar.Text:SetAllPoints();
        castBarMO.progressBar.Text:SetPoint("CENTER", 0, 0);
        castBarMO.progressBar.Text:SetFont(STANDARD_TEXT_FONT, 16, "OUTLINE");
        --castBarMO.progressBar.Text:SetTextHeight(20);
        --castBarMO.progressBar.Text:SetSize(185,16);

        -- 캐스트중인 대상표현
        castBarMO.progressBar.TargetText = castBarMO.progressBar:CreateFontString(nil, "OVERLAY");
        --castBarMO.progressBar.TargetText:SetAllPoints();
        castBarMO.progressBar.TargetText:SetPoint("LEFT", 20, 0);
        castBarMO.progressBar.TargetText:SetPoint("RIGHT", -20, 0);
        castBarMO.progressBar.TargetText:SetFont([[Fonts\2002.TTF]], 16, "OUTLINE");
        castBarMO.progressBar.TargetText:SetJustifyH("LEFT");
        castBarMO.progressBar.TargetText:SetText("캐스트오버"); -- 테스트용

        -- 차단자 표현
        castBarMO.progressBar.InterrupterText = castBarMO.progressBar:CreateFontString(nil, "OVERLAY");
        castBarMO.progressBar.InterrupterText:SetPoint("LEFT", 20, 0);
        castBarMO.progressBar.InterrupterText:SetPoint("RIGHT", -20, 0);
        castBarMO.progressBar.InterrupterText:SetFont([[Fonts\2002.TTF]], 16, "OUTLINE");
        castBarMO.progressBar.InterrupterText:SetJustifyH("RIGHT");
        castBarMO.progressBar.InterrupterText:SetText("차단자"); -- 테스트용

        castBarMO.progressBar.Icon:SetSize(32,32);
        
        castBarMO.progressBar.Spark:SetSize(32,32);
        castBarMO.progressBar.Flash:ClearAllPoints();
        --castBarMO.progressBar.Flash:SetAllPoints();
        castBarMO.progressBar.Flash:SetPoint("CENTER", 0, 0);
        castBarMO.progressBar.Flash:SetSize(1000,64);
        castBarMO.progressBar.Border:Hide();

        CastingBarFrame_OnLoad(castBarMO.progressBar, nil, true, false);
        
        -- hooksecurefunc("CastingBarFrame_OnUpdate" 으로 처리함
        --castBarMO.progressBar:HookScript("OnUpdate", LJDShowCastingBar_OnUpdate );
        
        castBarMO:Hide();
    end

    -- 툴팁 프레임 생성(target 전용)
    local tooltip = _G["LJDCastingToolip"];
    if( not tooltip ) then
        tooltip = CreateFrame("GameTooltip", "LJDCastingToolip", UIParent, "GameTooltipTemplate");
        tooltip:SetFrameStrata("LOW");   -- 가방뒤로 보낼려고
        tooltip:SetFrameLevel(100);      -- 퀘스트 위에 보일려고
        tooltip:SetMovable(true);
        tooltip:EnableMouse(true);
        tooltip:RegisterForDrag("LeftButton");
        tooltip:SetScript("OnDragStart", tooltip.StartMoving);
        tooltip:SetScript("OnDragStop", tooltip.StopMovingOrSizing);
        
        -- 닫기버튼 추가
        tooltip.closeBtn = CreateFrame("Button", "$parentCloseButton", tooltip);
        tooltip.closeBtn:SetSize(32,32);
        tooltip.closeBtn:SetPoint("TOPRIGHT",1,0);
        tooltip.closeBtn:SetNormalTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Up]]);
        tooltip.closeBtn:SetPushedTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Down]]);
        tooltip.closeBtn:SetHighlightTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Highlight]]);
        tooltip.closeBtn:SetScript("OnClick", function(self)
            tooltip:Hide();
        end);

        tooltip:SetOwner(TargetFrameSpellBar, "ANCHOR_BOTTOMRIGHT");    -- 초기위치 설정(타켓캐스팅 옆)
        
        local castBar = _G["LJDCastingBar"];
        if(castBar) then
            -- 초기위치 재설정(LJD캐스트바 옆)
            tooltip:ClearAllPoints();
            tooltip:SetPoint("TOPLEFT", castBar ,"TOPRIGHT", 0, 0);
        end
    end

    -- 툴팁 프레임 생성(MouseOver 전용툴팁)
    local tooltipMO = _G["LJDCastingToolipMO"];
    if( not tooltipMO ) then
        tooltipMO = CreateFrame("GameTooltip", "LJDCastingToolipMO", UIParent, "GameTooltipTemplate");
        tooltipMO:SetFrameStrata("LOW");   -- 가방뒤로 보낼려고
        tooltipMO:SetFrameLevel(100);      -- 퀘스트 위에 보일려고
        tooltipMO:SetMovable(true);
        tooltipMO:EnableMouse(true);
        tooltipMO:RegisterForDrag("LeftButton");
        tooltipMO:SetScript("OnDragStart", tooltipMO.StartMoving);
        tooltipMO:SetScript("OnDragStop", tooltipMO.StopMovingOrSizing);
        
        -- 닫기버튼 추가
        tooltipMO.closeBtn = CreateFrame("Button", "$parentCloseButton", tooltipMO);
        tooltipMO.closeBtn:SetSize(32,32);
        tooltipMO.closeBtn:SetPoint("TOPRIGHT",1,0);
        tooltipMO.closeBtn:SetNormalTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Up]]);
        tooltipMO.closeBtn:SetPushedTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Down]]);
        tooltipMO.closeBtn:SetHighlightTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Highlight]]);
        tooltipMO.closeBtn:SetScript("OnClick", function(self)
            tooltipMO:Hide();
        end);

        --tooltipMO:SetOwner(TargetFrameSpellBar, "ANCHOR_BOTTOMRIGHT");    -- 초기위치 설정(타켓캐스팅 옆)
        
        local castBar = _G["LJDCastingBar"];
        if(castBar) then
            -- 초기위치 재설정(LJD캐스트바 왼쪽옆)
            tooltipMO:ClearAllPoints();
            tooltipMO:SetPoint("TOPRIGHT", castBar ,"TOPLEFT", -35, 0);
        end
    end

    -- 타이머
    LJDCastingBarFrame:StartTimer();
    
end

-- Player 의 대상 변경시 캐스팅
function LJDCastingBarFrame:PLAYER_TARGET_CHANGED(...)
    local ll = {...};
    --DebugPrint(ll);
    --local unitId = "target";
    --local startSpellId = nil;

    LJDShowCastingBar();
    LJDShowCastingSpellToolip();
end

-- Player 의 마우스오버 변경시
function LJDCastingBarFrame:UPDATE_MOUSEOVER_CHANGED(...)
    local ll = {...};
    --DebugPrint(ll);
    --local unitId = "mouseover";
    --local startSpellId = nil;

    LJDShowCastingBar();
    -- 가장 최근 사용한 스킬 툴팁을 보여준다.
    LJDShowCastingSpellToolip();
end

-- 차단자 표시
-- ; 차단자는 전투로그에서 추출하는데, unitId가 없어서, UnitGUID으로 비교함.
function LJDCastingBarFrame:LJDShowInterrupter(...)
    local ll = {...};
    --DebugPrint(ll);
    
    local unitId   = ll[2];
    local castGUID = ll[3];
    local spellID  = ll[4];
    local unitGUID = unitId and UnitGUID(unitId);
    
    --if( not unitId ) then return; end;
    
    local interrupterText = nil;
    local interrupterTextNewFormat = nil;

    local timestamp, type, hideCaster,                                                                                           -- arg1  to arg3
        sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags,                        -- arg4  to arg11
        spellId, spellName, spellSchool,                                                                                           -- arg12 to arg14
        extraSpellId,extraSpellName,extraSchool, resisted, blocked, absorbed, critical, glancing, crushing = CombatLogGetCurrentEventInfo()       -- arg15 to arg23

    if( not type ) then
        return;
    end

    if( type == "SPELL_INTERRUPT" ) then
        unitGUID = destGUID;
        interrupterText = sourceName;
        --DebugPrint(destGUID..":"..destName..":"..interrupterText);
    end

    if( type == "SPELL_AURA_APPLIED" ) then
    
        --if( sourceName == UnitName("player") ) then
        --    DebugPrint(timestamp ..":".. type..":"..spellName..":"..spellId);
        --end
    
        -- 스턴스킬이면....
        if LJDIsStunSkill(spellId) then
            unitGUID = destGUID;
            interrupterText = sourceName;
            --DebugPrint(destGUID..":"..destName..":"..interrupterText..":"..spellId);
        end
    end
    
    if( not unitGUID ) then
        return;
    end

    if( not interrupterText ) then
        return;
    end

    local newName = nil;
    if(UnitIsUnit("player", interrupterText)) then
        newName = L["나"];
    end
    interrupterText = LJDGetClassColoredName(interrupterText, newName);
    interrupterTextNewFormat = "|cffffffff"..L["차단"].." |r" .. (interrupterText or ""); -- 흰색 "차단 " + 이름표
    
    if( type == "SPELL_AURA_APPLIED" ) then
        interrupterTextNewFormat = "|cffff00ff"..L["스턴"].." |r" .. (interrupterText or ""); -- 보라색 "스턴 " + 이름표
    end
    
    local castBar = _G["LJDCastingBar"];
    if( castBar.progressBar.unit ) then
        --DebugPrint(unitGUID..":"..UnitGUID(castBar.progressBar.unit));
        if( interrupterText and unitGUID == UnitGUID(castBar.progressBar.unit ) ) then
        --if( interrupterText and unitGUID == castBar.progressBar.castID ) then -- 안됨
            --interrupterTextNewFormat = "|cff00ff00"..L["차단"].." |r" .. interrupterText;
            --interrupterTextNewFormat = tostring(threatStatus);
            castBar.progressBar.Text:SetText(interrupterTextNewFormat);
            --castBar.progressBar.InterrupterText:SetText(interrupterTextNewFormat);
        end
    end

    castBar = _G["LJDCastingBarMO"];
    if( castBar.progressBar.unit ) then
        --DebugPrint(unitGUID..":"..UnitGUID(castBar.progressBar.unit));
        if( interrupterText and unitGUID == UnitGUID(castBar.progressBar.unit ) ) then
        --if( interrupterText and unitGUID == castBar.progressBar.castID ) then -- 안됨
            --interrupterTextNewFormat = "|cff00ff00"..L["차단"].." |r" .. interrupterText;
            --targetNameText = tostring(threatStatus);
            castBar.progressBar.Text:SetText(interrupterTextNewFormat);
            --castBar.progressBar.InterrupterText:SetText(interrupterTextNewFormat);
        end
    end
    
    ---------------------------------------------------------------------------
    -- 이하 기능 이름표의 시전바에도 차단자표현 기능.
    -- 이름표 모두와 비교하여, 차단정보와 일치하는 이름표에 차단자를 표시한다.
    ---------------------------------------------------------------------------
    local NamePlatesList = C_NamePlate.GetNamePlates();

    for i=1, #NamePlatesList do
        local unitFrame = NamePlatesList[i].UnitFrame;
        if( unitGUID == UnitGUID(unitFrame.displayedUnit) ) then
        --if( unitGUID == unitFrame.castBar.castID ) then -- 안됨
            
            unitFrame.castBar.Text:SetText(interrupterTextNewFormat);
            
            --if( unitFrame.castBar.InterrupterText ) then
                --interrupterTextNewFormat = "|cff00ff00"..L["차단"].." |r" .. interrupterText;
                --interrupterTextNewFormat = interrupterText;
                --unitFrame.castBar.InterrupterText:SetText(interrupterTextNewFormat);
            --end
        end
    end
end



-- 캐스팅바를 숨긴다.
--[[
function LJDHideCastingBar()
    local castBar = _G["LJDCastingBar"];
    if( castBar ) then
        castBar:Hide();
    end
    
    castBar = _G["LJDCastingBarMO"];
    if( castBar ) then
        castBar:Hide();
    end
    
end
--]]

-- OnUpdate 이벤트 대체용 타이머
function LJDCastingBarFrame:StartTimer()
    -------------------------------------------------------------------------
    -- 진득주 1)
    -- NewTicker 와 NewTimer에 관하여 .. 
    -- NewTicker는 세번째 인자 : 반복수(iterations)가 1인(한번) 
    -- NewTimer와 같다.
    -- (NewTicker의 기본값은 무한반복)
    -------------------------------------------------------------------------
    -- 진득주 2)
    -- Duration 이 0.001(1ms) 이하이면, 게임 클라이언트에 영향을 줄수 있다.
    -- 적어도, 60 FPS를 지켜 보려면, 60 FPS 가 0.016 s(f=1/t) 이므로, 
    -- 대강 0.01 보단 높게 설정하게 한다.
    -- 아래 math.max 가 그 역할용으로 최소값을 지정했다. 
    -------------------------------------------------------------------------
	if not LJDCastingBarFrame.ticker then
		LJDCastingBarFrame.ticker = C_Timer.NewTicker(0.2, function() LJDCastingBarFrame:onTimer() end );   -- 60 프레임 지켜보려고..
	end
end

function LJDCastingBarFrame:StopTimer()
	if LJDCastingBarFrame.ticker then
		LJDCastingBarFrame.ticker:Cancel();
		LJDCastingBarFrame.ticker = nil;
	end
end

-- UPDATE_MOUSEOVER_UNIT + lost 이벤트 구현(UPDATE_MOUSEOVER_CHANGED)
function LJDCastingBarFrame:onTimer()

    ------------------------------------------------------------------------------
    -- UPDATE_MOUSEOVER_UNIT 이벤트는 유닛이 lost 된 경우 발생하지 않는다.
    -- 이를 보완하기 위해(lost 된 경우만) 추가 호출함.
    ------------------------------------------------------------------------------
    local unitId = "mouseover";
    local existsMouseOverUnit = UnitExists(unitId);

    if( LJDExistsMouseOverUnit ~= existsMouseOverUnit ) then
        LJDExistsMouseOverUnit = existsMouseOverUnit;
        
        if( not existsMouseOverUnit ) then
            LJDCastingBarFrame.UPDATE_MOUSEOVER_CHANGED(self, "UPDATE_MOUSEOVER_UNIT");
        end
    end

end

-- 이름표 차단자 표현준비
function LJDDrawInterrupter( unitId )
    -- 20201122
    -- UnitFrame에도 차단자 표현 기능
    if( not unitId ) then return; end;
    local castBar = nil;

    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitId, issecure());
    if (plateFrame) then
        castBar = plateFrame.UnitFrame.castBar;
    end
    
    if( not castBar ) then return end;
    
    -- 차단자 표현용 FontString 생성
    if( not castBar.InterrupterText ) then
        castBar.InterrupterText = castBar:CreateFontString(nil, "OVERLAY");
        castBar.InterrupterText:SetPoint("LEFT", castBar, "RIGHT", 4, 0);
        castBar.InterrupterText:SetFont([[Fonts\2002.TTF]], 13, "OUTLINE");
        castBar.InterrupterText:SetJustifyH("LEFT");
        castBar.InterrupterText:SetText("차단자"); -- 테스트용
    end
    
    castBar.InterrupterText:SetText("");    -- 초기화
end

-- 캐스팅바를 보여준다.
function LJDShowCastingBar(unitId, spellId)

    LJDShowCastingBarTarget(unitId or "target");
    LJDShowCastingBarMO(unitId or "mouseover");
    
    -- 이름표 차단자 표현준비
    LJDDrawInterrupter(unitId);
end

-- 캐스팅바를 보여준다.(대상 전용)
function LJDShowCastingBarTarget(unitId, spellId)
    --DebugPrint(unitId);
    --if( unitId ~= "target" and not UnitIsUnit(unitId, "mouseover") ) then

    if( not UnitIsUnit(unitId, "target") ) then
        return;
    end
    
    if( UnitIsFriend("player", unitId) or UnitIsDead(unitId)) then
        return;
    end

    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitId, issecure());
    if (plateFrame) then
        unitId = plateFrame.UnitFrame.unit;
    end

    -- [캐스팅바 보기] 설정에 따라 표현
    if( not LJDSpellInterruptDB["ShowCastingBar"] ) then
        return;
    end

    -- 즉시 시전 스킬인 경우(UNIT_SPELLCAST_SUCCEEDED 이벤트)를 감안하여
    -- 스킬정보를 매번 다시 확인한다.
    local name, text, texture, startTimeMS, endTimeMS, isTradeSkill, castID, notInterruptible;
    name, text, texture, startTimeMS, endTimeMS, isTradeSkill, castID, notInterruptible, spellId = UnitCastingInfo(unitId);
    if( not name ) then
        name, text, texture, startTimeMS, endTimeMS, isTradeSkill, notInterruptible, spellId = UnitChannelInfo(unitId);
    end
    --DebugPrint(spellId);

    
    local castBar = _G["LJDCastingBar"];
    if( castBar ) then
        
        -- 차단자 초기화
        castBar.progressBar.InterrupterText:SetText("");
    
        if( not spellId ) then
            castBar:Hide();
            return;
        end

        -- 차단불가한 스킬이면 숨김
        if( notInterruptible ) then
            --castBar:Hide();
            --return;
        end

        CastingBarFrame_SetUnit(castBar.progressBar, unitId, true, false);
        castBar:Show();
        
        if( UnitExists("mouseover") and UnitIsEnemy("player", "mouseover") and not UnitIsDead("mouseover")) then
        --if( UnitExists("mouseover")  _G["LJDCastingBarMO"]:IsShown() ) then
            castBar:Hide();
        end
        
    end

    --DebugPrint(castBar:GetName() .. ":" .. castBar.progressBar.unit );

end


-- 캐스팅바를 보여준다.(마우스오버 전용)
function LJDShowCastingBarMO(unitId, spellId)
    --DebugPrint(unitId);
    --if( unitId ~= "target" and not UnitIsUnit(unitId, "mouseover") ) then

    if( not UnitIsUnit(unitId, "mouseover") ) then
        return;
    end

    if( UnitIsFriend("player", unitId) or UnitIsDead(unitId)) then
        return;
    end

    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitId, issecure());
    if (plateFrame) then
        unitId = plateFrame.UnitFrame.unit;
    end

    -- [캐스팅바 보기] 설정에 따라 표현
    if( not LJDSpellInterruptDB["ShowCastingBar"] ) then
        return;
    end

    -- 즉시 시전 스킬인 경우(UNIT_SPELLCAST_SUCCEEDED 이벤트)를 감안하여
    -- 스킬정보를 매번 다시 확인한다.
    local name, text, texture, startTimeMS, endTimeMS, isTradeSkill, castID, notInterruptible;
    name, text, texture, startTimeMS, endTimeMS, isTradeSkill, castID, notInterruptible, spellId = UnitCastingInfo(unitId);
    if( not name ) then
        name, text, texture, startTimeMS, endTimeMS, isTradeSkill, notInterruptible, spellId = UnitChannelInfo(unitId);
    end
    --DebugPrint(spellId);

    local castBar = _G["LJDCastingBarMO"];
    if( castBar ) then
    
        -- 차단자 초기화
        castBar.progressBar.InterrupterText:SetText("");
    
        if( not spellId ) then
            castBar:Hide();
            return;
        end

        -- 차단불가한 스킬이면 숨김
        if( notInterruptible ) then
            --castBar:Hide();
            --return;
        end
    
        CastingBarFrame_SetUnit(castBar.progressBar, unitId, true, false);
        castBar:Show();
        --[[
        -- 캐스팅 대상 표시
        local unitTargetId = unitId.."target";
        local newName = nil;
        if(UnitIsUnit(unitId, unitTargetId)) then
            newName = "SELF";
        elseif(UnitIsUnit("player", unitTargetId)) then
            newName = L["나"];
        end
        local targetNameText = LJDGetClassColoredName(unitTargetId, newName);
        
        if( targetNameText ) then
            --targetNameText = "|cff00ff00"..L["대상"].." |r" .. targetNameText;
            --targetNameText = tostring(threatStatus);
            castBar.progressBar.TargetText:SetText(targetNameText);
        end
        --]]

    end

    --DebugPrint(castBar:GetName() .. ":" .. castBar.progressBar.unit );

end

-- 캐스팅바 OnUpdate 처리
-- ; 1 .캐스팅 대상 표현(대상, 마우스오버 함께 사용)
function LJDShowCastingBar_OnUpdate(self, elapsed)
    --local ll = {...};
    --DebugPrint(self:GetName());
    --DebugPrintTable(self);

    if( not self.unit ) then return end;
    
    -- 캐스팅 대상 표시
    local unitTargetId = self.unit.."target";
    --DebugPrint(unitTargetId);
    local newName = nil;
    if(UnitIsUnit(self.unit, unitTargetId)) then
        newName = "SELF";
    elseif(UnitIsUnit("player", unitTargetId)) then
        newName = L["나"];
    end
    local targetNameText = LJDGetClassColoredName(unitTargetId, newName);

    if( targetNameText and self.TargetText ) then
        
        --targetNameText = "|cff00ff00"..L["대상"].." |r" .. targetNameText;
        --targetNameText = tostring(threatStatus);
        self.TargetText:SetText(targetNameText);
    end
    
end
hooksecurefunc("CastingBarFrame_OnUpdate", LJDShowCastingBar_OnUpdate);


-- 가장 최근 사용한 스킬 툴팁을 보여준다.
function LJDShowCastingSpellToolip(unitId, startSpellId)

    -- 툴팁은 대상은 오른쪽, 마우스오버는 왼쪽에 동시에 표현된다.
    LJDShowCastingSpellToolipTarget(unitId or "target", startSpellId);  -- 대상
    LJDShowCastingSpellToolipMO(unitId or "mouseover", startSpellId);   -- 마우스오버

end

-- 가장 최근 사용한 스킬 툴팁을 보여준다.(대상용)
function LJDShowCastingSpellToolipTarget(unitId, spellId)

    -- Player의 타켓인 경우만
    --if( not UnitIsUnit("playertarget", unitId ) ) then    -- 요건 두번씩 실행된다. 각 unitFrame과 targetFrame.
    --if( not UnitIsUnit(unitId, "target") and not UnitIsUnit(unitId, "mouseover") ) then
    if( not UnitIsUnit(unitId, "target") ) then
        return;
    end

    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitId, issecure());
    if (plateFrame) then
        unitId = plateFrame.UnitFrame.unit;
    end

    -- [캐스팅 툴팁 보기] 설정에 따라 표현
    if( not LJDSpellInterruptDB["ShowCastingTooltip"] ) then
        return;
    end

    -- 스킬정보 없는 경우는 재확인
    if( not spellId ) then
        spellId = select(9,UnitCastingInfo(unitId)) or select(8,UnitChannelInfo(unitId));
        if( not spellId ) then
            return;
        end
    end

    local tooltip = _G["LJDCastingToolip"];
    tooltip.IsTarget = true;

    LJDDrawCastingSpellTooltip(tooltip, unitId, spellId);

end

-- 가장 최근 사용한 스킬 툴팁을 보여준다.(마우스오버용)
function LJDShowCastingSpellToolipMO(unitId, spellId)

    -- Player의 타켓인 경우만
    --if( not UnitIsUnit("playertarget", unitId ) ) then    -- 요건 두번씩 실행된다. 각 unitFrame과 targetFrame.
    --if( not UnitIsUnit(unitId, "target") and not UnitIsUnit(unitId, "mouseover") ) then
    if( not UnitIsUnit(unitId, "mouseover") ) then
        return;
    end

    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitId, issecure());
    if (plateFrame) then
        unitId = plateFrame.UnitFrame.unit;
    end

    -- [캐스팅 툴팁 보기] 설정에 따라 표현
    if( not LJDSpellInterruptDB["ShowCastingTooltip"] ) then
        return;
    end

    -- 스킬정보 없는 경우는 재확인
    if( not spellId ) then
        spellId = select(9,UnitCastingInfo(unitId)) or select(8,UnitChannelInfo(unitId));
        if( not spellId ) then
            return;
        end
    end

    local tooltip = _G["LJDCastingToolipMO"];
    tooltip.IsTarget = false;
    
    LJDDrawCastingSpellTooltip(tooltip, unitId, spellId);
end


-- 툴팁을 그린다.(대상, 마우스오버 함께 사용함)
function LJDDrawCastingSpellTooltip(tooltip, unitId, spellId)

    if( tooltip ) then
        --local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(spellId);
        local spellLink = GetSpellLink(spellId);
        if( not spellLink ) then
            --DebugPrint("SpellLink Nil : " .. spellId );
            return;
        end
        
        tooltip:SetOwner(UIParent, "ANCHOR_PRESERVE");  -- 혹시 옮기면 옮긴자리 유지.(ANCHOR_PRESERVE)
        tooltip:SetHyperlink(spellLink);

        -- GameTooltipTemplate.xml 파일에서 오른쪽 상단 FontString 있음을 확인함.
        -- 여기선, LJDCastingToolipTextRight1
        local textRight1 = _G[tooltip:GetName().."TextRight1"];
        if( textRight1 ) then
            --textRight1:SetText("(15 초만 보임)");
            textRight1:SetText(LJDGetClassColoredName(unitId).."  X");  -- 닫기버튼 표시 위치 위해 좀 띄움(X는 의미 없음)
            textRight1:Show();  -- 기본숨김처리 되어있음.
            tooltip:Show(); -- ReDraw
        end

        local textRight2 = _G[tooltip:GetName().."TextRight2"];
        if( textRight2 ) then
            if( tooltip.IsTarget ) then
                textRight2:SetText("|c".."ffff00ff".."대상".."|r");   -- 보라색
                --textRight2:SetText(LJDGetClassColoredName(unitId, "대상"));
            else
                textRight2:SetText("|c".."ff00ff00".."마우스오버".."|r"); -- 초록색
                --textRight2:SetText(LJDGetClassColoredName(unitId, "마우스오버"));
            end
            
            textRight2:Show();  -- 기본숨김처리 되어있음.
            tooltip:Show(); -- ReDraw
        end
        --tooltip:SetScale(0.9);

        ------------------------------------------------
        -- 마지막 스킬이 사용되고, 15초뒤 툴팁 자동숨김
        -- (1초 단위로 남은시간 표현)
        ------------------------------------------------
        if( tooltip.timerShowTooltop and not tooltip.timerShowTooltop:IsCancelled() ) then
            tooltip.timerShowTooltop:Cancel();  -- 최신스킬이 사용되었으니 시간갱신위해 중지
            tooltip.timerShowTooltop = nil;
        end
        
        -- 1초마다 실행될 calback 함수
        local function calbackPerSecond(timer)
            
            if(timer._remainingIterations > 1) then
                -- 정신사나움
                --LJDCastingToolipTextRight1:SetText(tostring( timer._remainingIterations - 1 ).." 초후 툴팁사라짐");
            else
                -- 숨김
                tooltip:Hide();
            end
        end
        
        -- [캐스팅 툴팁 자동숨기기] 설정에 따라
        if( not LJDSpellInterruptDB["AutoHideCastingTooltip"] ) then
            return;
        end

        -- 1초간격 15번 calbackPerSecond 수행
        tooltip.timerShowTooltop = C_Timer.NewTicker( 1, calbackPerSecond, 15);
    end

end

-- 스턴스킬인지 판단
function LJDIsStunSkill(spellId)

    local StunAuraIdList = {
        --전사
        --105771, -- 전쟁인도자 (전사) 돌진시 대상 3초 기절
        132169, -- 폭풍망치 (전사) 무기공격력의 100% 입히고 3초 기절 기절 영구면역 대사은 300% 추가피해 30초 쿨
        132168, -- 충격파 (전사)  대상 4초 스턴 20초 쿨
        --도적
        13953, -- 마비독 (도적) 113953 , 113952
        1833,  -- 비열한 습격 (도적) -적을 공격하여4초동안 기절
        408,   -- 급소 가격 (도적) -2,3,4,5,6초 20초쿨 408

        --마법사
        118271, -- 발화 (법사) 즉시 16.195의 화염 피해를 입히고 3초동안 대상 기절시킵니다. 45초쿨
        44572, -- 동결 (법사) 5초동안 대상을 기절 시킵니다.
         -- 흑마법사
        85387, -- 재앙의 여파 (흑마)
        30283, -- 어둠의 격노 (흑마)
        6789,  -- 죽음의 고리(흑마)
        89766, -- 도끼 던지기 (흑마)
        --사냥꾼
        117405, -- 구속의 사격 (냥꾼)
        24394, -- 위협 (냥꾼) 적을 위협하도록 야수에게 명령합니다. 3초 동안 대상 기절 1분쿨
        96201, -- 거미줄 감싸기 (냥꾼) 기절 3초 31.5초 쿨
        19503, -- 위협 (냥꾼) 적을 위협하도록 야수에게 명령합니다. 3초 동안 대상 기절.
         --드루이드
        102795, -- 격한 포옹 (드루)근접 공격을 가해 3초 동안 적을 기절시키고 1초 마다 자신의 생명력의 10%해당하는 피해를 줍니다. 자신은 3초동안 이동 물가 상태가 됩니다. 이 기술을 사용하면 곰으로 변신합니다. 1분 후 재사용
        9005,  -- 암습 (드루) 적을 암습하여 4초 동안 기절 시키고 18초에 걸쳐 총 4,578의 출혈 피해를 입힙니다. 숨은 상태로 공격해야 합니다.
        24394, -- 거센 강타 (드루) 우르속의 혼을 일꺠워 6초 동안 대상을 기절 시킵니다. 모든 변신상태에서 가능합니다
        22570, -- 무력화 (드루)
        102280,  -- 야수 탈주 - 최대 20미터 전방으로 순간이동 하고 표범으로 변신하여 숨기를 활성화 합니다 30초 후 재사용
        --주술사
        118905, -- 축전 토템 (술사) 시전자 위치에 5의 생명력을 지닌 바람의 토템을 소환하고 토템은 5초 후 폭발해서 8미터 이내에 모든 적에게 5초 동안 기절시킵니다.
        --성기사
        105593, -- 심판의 망치 (기사) 6초 동안 대상을 기절 시킵니다. 30초 후 재사용
        853,   -- 심판의 망치 (기사) 6초 동안 대상을 기절 시킵니다. 1분 후 재사용
        --죽음의 기사
        91800, -- 물어뜯기 (죽기) 대상을 3초 동안 기절 시킵니다. 1분 후 재사용
        91797, -- 무시무시한 일격 (죽기) 대상을 4초 기절 시킵니다. 1분 후 재사용
        47481, -- 구울 스턴 (죽기)
        108194, -- 어둠의 질식 (죽기특성) 대상을 5초 동안 기절 시킵니다. 1분 후 재사용
        115001,  -- 냉혹한 겨울 (죽기) 5회 중첩시 6초 동안 대상 기절
        
        --수도사
        119392, -- 황소 쇄도 (수도) 경로내 모든 적을 3초 동안 기절 시킵니다. 1분 후 재사용
        120086, -- 분노의 주먹 (수도) 전방에 모든 적에게 4초동안 기절 시킵니다. 1초마다 피해를 입힙니다 25초 후 재사용
        119381, -- 팽이 차기 (수도) 반경 5미터 모든 적을 5초 동안 기절 시킵니다 - 45초 후 재사용
        122242, -- 충돌 (수도) 수도사와 대상의 중간에서 충돌하여 6미터 안에 모든 대상을 기절 시킵니다. 35초 후 재사용
        
        255723, -- 황소 돌진(높은산 타우렌 종족스킬 ) 1초 동안 전방으로 돌진하여, 1.5초 동안 적을 쓰러뜨립니다.
        
        -- 악마사냥꾼
        200166, -- 탈태
        204490,
        217822, -- 감금
    };

    local isStunSkill = false;
    --local isStunSkill = StunAuraIdList[spellId];

    for i=1, #StunAuraIdList do
        if spellId == StunAuraIdList[i] then
            isStunSkill = true;
            break;
        end;
    end

    return isStunSkill;
end

