-----------------------------------------------------
-- lua 파일이 여러개인 경우
-- 애드온명, 애드온내공유테이블이 ...으로 전달됨
-----------------------------------------------------
local addonName, L = ...;

local CenterButton = CreateFrame("FRAME");
CenterButton:SetScript('OnEvent', function(self, event, ...)
    return self[event] and self[event](self, event, ...)
end)

function CenterButton:PLAYER_ENTERING_WORLD()
    ------------------------------------------
    -- 버튼 초기화
    ------------------------------------------
    local btn = _G["RestoreActionBarButton"];
    if( not btn ) then
        --Button 화면중앙 버튼정렬 위치 초기화
        btn = CreateFrame("Button", "RestoreActionBarButton", UIParent, "GameMenuButtonTemplate", 0);
        btn:SetSize(80, 40);
        btn:SetText(L["버튼 초기화"]);
        btn:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -340, 20);
        --btn:RegisterForClicks("AnyUp", "AnyDown");
        btn:RegisterForClicks("AnyUp");
        btn:SetNormalFontObject("GameFontNormalLarge");
        btn:SetHighlightFontObject("GameFontHighlightLarge");
        btn.tooltipText        = L["Ctrl-Shift-마우스 좌버튼 드래그로 버튼위치를 변경할수 있습니다.\nCtrl-Shift-마우스 우버튼 드래그로 버튼크기를 변경할수 있습니다."];  -- 툴팁
        btn.tooltipRequirement = L["위치를 초기화 합니다."];         -- 툴팁2
        btn:SetScript("OnEnter", function(self)
            if self.tooltipText then
                GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
                GameTooltip:SetText(self.tooltipText, 1.0, 1.0, 0.00, 0.75, true);
            end
            if self.tooltipRequirement then
                GameTooltip:AddLine(self.tooltipRequirement, 1.0, 1.0, 1.0)
                GameTooltip:Show()
            end
        end );
        btn:SetScript("OnLeave", function(self)
            GameTooltip:Hide()
        end );
        
        btn:SetScript ("OnClick", LJDResoreActionBar_OnClick );
        
        -- 액션버튼 이동가능하게 변경
        LJDActionButton_SetMoveable(btn);
        
        -- 20191228 버튼 숨김
        btn:Hide();
    end

    -- 징벌기사 하단 자원 키우기
    if( ClassNameplateBarPaladinFrame ) then
        ClassNameplateBarPaladinFrame:SetScale(1.3);
    end

    -- 화면중앙버튼정렬
    -- LJDSpellInterrupt_CenterButton()를 사용하지 않는 이유는
    -- 설정에서 화면중앙버튼정렬 체크해제시 초기화(centerButtonCancel())도 안하기 위함.(타 애드온사용자 배려)
    if( LJDSpellInterruptDB["CenterSkillButton"] ) then
        LJDCenterButtonAlign();
    end

    -- SpellLink 디버그용(접속하는 케릭터가 가진 스킬이어야 함. [초급 타기]는 공용이므로)
    --print(GetSpellLink("초급 타기"));

end
CenterButton:RegisterEvent('PLAYER_ENTERING_WORLD');

function CenterButton:MODIFIER_STATE_CHANGED(...)
    --DebugPrint({...});
    
    -- 움직임 가능한 액션버튼 모두 반짝임
    -- 컨트롤 + 시프트
    if( IsControlKeyDown() and IsShiftKeyDown() ) then
        LJDActionBar_Moveable_Show();
        SetCursor('INTERACT_CURSOR');
    else
        LJDActionBar_Moveable_Hide();
        ResetCursor();
    end
end
CenterButton:RegisterEvent('MODIFIER_STATE_CHANGED');

function LJDCenterButtonInit()

    -- 크기 초기화
    LJDActionBar_SizeInit();

    -- 기준 프레임 위치 초기화
    --
    MultiBarRight:ClearAllPoints();
    MultiBarRight:SetPoint("TOPRIGHT",VerticalMultiBarsContainer,"TOPRIGHT",0,0);
    MultiBarLeft:ClearAllPoints();
    MultiBarLeft:SetPoint("TOPRIGHT", MultiBarRight, "TOPLEFT", -VERTICAL_MULTI_BAR_HORIZONTAL_SPACING, 0);
    
    MultiBarBottomLeft:ClearAllPoints();
    MultiBarBottomLeft:SetPoint("TOP",MainMenuBarArtFrame,"TOP",0,16);
    MultiBarBottomLeft:SetPoint("BOTTOMLEFT",ActionButton1,"TOPLEFT",0,13);
    MultiBarBottomRight:ClearAllPoints();
    MultiBarBottomRight:SetPoint("TOP",MainMenuBarArtFrame,"TOP",-30,90);
    MultiBarBottomRight:SetPoint("TOPLEFT",ActionButton12,"TOPRIGHT",45,2);
    --]]
    
    -------------------------------------------------
    -- 위치 초기화
    -------------------------------------------------
    -- 1. 세로 멀티바(MultiBarRight, MultiBarLeft)
    -- 1-1. MultiBarRight
    MultiBarRightButton1:ClearAllPoints();
    MultiBarRightButton1:SetPoint("TOPRIGHT",MultiBarRight,"TOPRIGHT",-2,-3);

    for j=2,12 do
        _G["MultiBarRightButton"..j]:ClearAllPoints();
        _G["MultiBarRightButton"..j]:SetPoint("TOP", _G["MultiBarRightButton"..(j-1)],"BOTTOM",0,-6);
    end

    -- 1-2. MultiBarLeft
    MultiBarLeftButton1:ClearAllPoints();
    MultiBarLeftButton1:SetPoint("TOPRIGHT",MultiBarLeft,"TOPRIGHT",-2,-3);

    for j=2,12 do
        _G["MultiBarLeftButton"..j]:ClearAllPoints();
        _G["MultiBarLeftButton"..j]:SetPoint("TOP", _G["MultiBarLeftButton"..(j-1)],"BOTTOM",0,-6);
    end

    -- 2. 가로 멀티바(MultiBarBottomLeft, MultiBarBottomRight)
    -- 2-1. MultiBarBottomLeft
    MultiBarBottomLeftButton1:ClearAllPoints();
    MultiBarBottomLeftButton1:SetPoint("BOTTOMLEFT", MultiBarBottomLeft, "BOTTOMLEFT",0,0);

    for j=2,12 do
        _G["MultiBarBottomLeftButton"..j]:ClearAllPoints();
        _G["MultiBarBottomLeftButton"..j]:SetPoint("LEFT", _G["MultiBarBottomLeftButton"..(j-1)],"RIGHT",6,0);
    end

    -- 2-2. MultiBarBottomRight1 ~ 6
    MultiBarBottomRightButton1:ClearAllPoints();
    MultiBarBottomRightButton1:SetPoint("BOTTOMLEFT", MultiBarBottomRight,"BOTTOMLEFT",0, 0);

    for j=2,6 do
        _G["MultiBarBottomRightButton"..j]:ClearAllPoints();
        _G["MultiBarBottomRightButton"..j]:SetPoint("LEFT", _G["MultiBarBottomRightButton"..(j-1)],"RIGHT",6,0);
    end

    -- 2-3. MultiBarBottomRight7 ~ 12
    MultiBarBottomRightButton7:ClearAllPoints();
    MultiBarBottomRightButton7:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton1,"TOPLEFT",0, 13);

    for j=8,12 do
        _G["MultiBarBottomRightButton"..j]:ClearAllPoints();
        _G["MultiBarBottomRightButton"..j]:SetPoint("LEFT", _G["MultiBarBottomRightButton"..(j-1)],"RIGHT",6,0);
    end

    -- 3. ActionButton  -- ActionButton 이동시 심히 이상해 진다. 기본버튼은 손대지 않는걸로..
    --
    --ActionButton1:ClearAllPoints();
    --ActionButton1:SetPoint("BOTTOMLEFT", MainMenuBarArtFrame,"BOTTOMLEFT",8,4);
    --[[
    for j=2,12 do
        _G["ActionButton"..j]:ClearAllPoints();
        _G["ActionButton"..j]:SetPoint("LEFT", _G["ActionButton"..(j-1)],"RIGHT",6,0);
    end
    --]]
end

function LJDCenterButtonAlign()

    -- 초기화
    LJDCenterButtonInit();
    --if 1==1 then return; end;
    
    -- 크기 초기화
    --MultiBarLeft:SetScale(1);
    --MultiBarRight:SetScale(1);

    -- 스킬창Left3 이동(왼쪽 기준)
    local L=MultiBarLeftButton3;
    L:ClearAllPoints();
    L:SetPoint("CENTER",UIParent,"CENTER",-550,100);

    -- 스킬창Right4 이동(오른쪽 기준)
    local R=MultiBarRightButton3;
    R:ClearAllPoints();
    R:SetPoint("CENTER",UIParent,"CENTER",550,100);

    -- 왼쪽2열 스킬창이동(왼쪽기준에 붙임)
    L=MultiBarLeftButton8;
    L:ClearAllPoints();
    L:SetPoint("TOPLEFT",MultiBarLeftButton3,"TOPRIGHT",6,0);

    -- 오른쪽2열 스킬창이동(오른쪽기준에 붙임)
    R=MultiBarRightButton8;
    R:ClearAllPoints();
    R:SetPoint("TOPRIGHT",MultiBarRightButton3,"TOPLEFT",-6,0);

    -- 크기조절(3~12만)
    local ls=0.85;
    for i,v in ipairs{"Left","Right"} do
        local n="MultiBar"..v.."Button"
        for j=3,12 do
            local btn= getglobal(n..j);
            btn:SetScale(ls)
        end;
    end

    -- 이동 및 크기변경 가능한 액션바로 변경.
    LJDActionBar_SetMoveable();
    
    -- 저장된 버튼정보(위치, 크기) Load.
    LJDActionBar_LoadPosition();
end

function LJDCenterButtonCancel()

    -- 초기화
    LJDCenterButtonInit();

    --[[
    -- 크기 초기화
    -- 크기조절(3~12만)
    local ls=1;
    for i,v in ipairs{"Left","Right"} do
        local n="MultiBar"..v.."Button"
        for j=3,12 do
            local btn= getglobal(n..j);
            btn:SetScale(ls)
        end;
    end

    MultiBarLeftButton3:ClearAllPoints();
    MultiBarLeftButton8:ClearAllPoints();
    MultiBarLeftButton3:SetPoint("TOPLEFT",MultiBarLeftButton2,"BOTTOMLEFT",0,-6);
    MultiBarLeftButton8:SetPoint("TOPLEFT",MultiBarLeftButton7,"BOTTOMLEFT",0,-6);

    MultiBarRightButton3:ClearAllPoints();
    MultiBarRightButton8:ClearAllPoints();
    MultiBarRightButton3:SetPoint("TOPLEFT",MultiBarRightButton2,"BOTTOMLEFT",0,-6);
    MultiBarRightButton8:SetPoint("TOPLEFT",MultiBarRightButton7,"BOTTOMLEFT",0,-6);
    --]]

end

function LJDSpellInterrupt_CenterButton()
    if( LJDSpellInterruptDB["CenterSkillButton"] ) then
        LJDCenterButtonAlign();
    else
        LJDCenterButtonCancel();
    end
end

--액션바 초기화 처리.
function LJDResoreActionBar_OnClick(self, mButton, bDown)
    --LJDActionButtonPosDB = {};  -- 버튼정보 초기화
    wipe(LJDActionButtonPosDB);
    LJDSpellInterrupt_CenterButton();
end

